import os

class Config:

    def _read_from_env(key: str, default: str = None) -> str:
        if (value := os.environ.get(key, default)) is not None:
            return value
        raise Exception(f'[Config] Error: Cannot find required value {key}')

    mqtt_broker    = _read_from_env('MQTT_BROKER')
    mqtt_port      = int(_read_from_env('MQTT_PORT','1883'))
    mqtt_client_id = _read_from_env('MQTT_CLIENT')
    mqtt_user_name = _read_from_env('MQTT_USERNAME')
    mqtt_password  = _read_from_env('MQTT_PASSWORD')

    keycloak_url       = _read_from_env('KEYCLOAK_URL')
    keycloak_user_name = _read_from_env('KEYCLOAK_USER_NAME')
    keycloak_password  = _read_from_env('KEYCLOAK_USER_PW')
    keycloak_realm     = _read_from_env('KEYCLOAK_REALM')

    db_host_name = _read_from_env('DB_HOSTNAME')
    db_user_name = _read_from_env('DB_USERNAME')
    db_password  = _read_from_env('DB_PASSWORD')
    db_database  = _read_from_env('DB_DATABASE')
    db_port      = int(_read_from_env('DB_PORT','5432'))

    machines      = _read_from_env('MACHINES')